<?php
#################################################################
#  Beispielscript für den Zugriff auf das my-Warehouse XML API  #
#  Copyright 2010 by STAPIS GmbH                                #
#  Mehr Ressourcen, Dokumentation etc. unter                    #
#  http://www.my-warehouse.de/xml_schnittstelle.html            #
#################################################################

############### Konstanten ###############

# Konstanten für den Zugriff, bitte mit gültigen Werten ausfüllen
define('MAIN_URL','http://www.shopdomain.de/');
define('XML_API_SCRIPT','xml_api.php');
define('USER_AGENT','my-Warehouse TESTAPP');
define('API_USER','');
define('API_PASS','');
define('API_KEY','');

############### Funktionen ###############

# Funktion für das XML parsen
function xml2array ($to_parse) {
  $array = simplexml_load_string ($to_parse);
  return $array ;
}

# Funktion um den eigentlichen HTTP Request abzusetzen
function send_request ($to_send) {
  $vars = "xml=" . urlencode(to_send);
  $url_teile = parse_url(MAIN_URL);
  $host = $url_teile['host'];
  $service_uri = $url_teile['path'] . XML_API_SCRIPT;
  $header = "Host: $host\r\n";
  $header .= "User-Agent: " . USER_AGENT . "\r\n";
  $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
  $header .= "Content-Length: ".strlen($vars)."\r\n";
  $header .= "Connection: close\r\n\r\n";
  $fp = @fsockopen($host, 80, $errno, $errstr);
  if (!$fp) {
    return "Fehler !!! $errstr ($errno)<br/>\r\n";
  } else {
    fputs($fp, "POST $service_uri  HTTP/1.1\r\n");
    fputs($fp, $header.$vars);
    $response = fread($fp, 128000);
    fclose($fp);
    return $response;
  }
}

############### Beispielcode ###############

# Befüllen eines gültigen XML Calls (get_api_data, mehr siehe Dokumentation unter http://www.my-warehouse.de/xml_schnittstelle.html)
$xml = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<document>
 <call>
  <authentification>
   <user>' . API_USER . '</user>
   <pass>' . API_PASS . '</pass>
   <api_key>' . API_KEY . '</api_key>
  </authentification>
  <action>get_api_data</action>
 </call>
</document>
';
# führe HTTP Request aus
$response = send_request ($xml);
if (substr_count($response, "Fehler !!!") > 0) {
# Es wurde ein Fehler zurückgegeben!!!
  echo $response;
} else {
# Rückgabewert wird geparst
  $result = xml2array ($response);
  var_dump ($result);
}

?>